% Spigoli1.pl

% Programma che partendo da una configurazione in cui tutti i pezzi sono fuori posto riesce a sistemare le
% posizioni degli spigoli, senza curarsi per della posizione dei vertici.
% La differenza rispetto a "spigoli1.pl"  che qui le sequenze invertono due soli spigoli (trovate con "cercaspigoli.pl").
% Sistemando gli spigoli in ordine casuale: 2 secondi con 16 mosse totali.
% Sistemando gli spigoli secondo l'ordine:
%[[bv,x],[br,x],[bg,x],[ba,x],[vr,y],[gr,y],[ga,y],[va,y],[ca,x],[cg,x],[cr,x],[cv,x]],ci vuole meno di 1 secondo in 10 mosse.
% Sistemando l'orientamento contemporaneamente alla posizione, il tempo passa da 1 secondo a 35 secondi:
% Questo  dovuto alla maggiore profondit di ricerca necessaria, ma anche alle mosse che devono contenere pi parametri.

% [[pezzo,direzione]]:
% b=bianco, v=verde, r=rosso, a=arancio, g=giallo, c=cobalto (blu).
% x direzione bianco-cobalto, y direzione verde-giallo, z direzione rosso-arancio.
% la prima lettera indica il colore rispetto cui  riferita la direzione.
spigoli_ok([[bv,x],[br,x],[bg,x],[ba,x],[vr,y],[gr,y],[ga,y],[va,y],[ca,x],[cg,x],[cr,x],[cv,x]]).
%	         1	     2         3        4	        5	    6	7         8	       9       10     11       12

% MOSSA_S_2 e MOSSA_S_O
% Mosse per cercare di sistemare gli spigoli.
mossa_s_2(bv8, [BV,BR|Rest], [BR,BV|Rest]). % Sequenza: [b,v,b,v3,b,v,b2,v3]
mossa_s_2(br8, [BV,BR,BG|Rest], [BV,BG,BR|Rest]).
mossa_s_2(bg8, [BV,BR,BG,BA|Rest], [BV,BR,BA,BG|Rest]).
mossa_s_2(ba8, [BV,BR,BG,BA|Rest], [BA,BR,BG,BV|Rest]).
mossa_s_2(vb8, [BV,BR,BG,BA,VR,GR,GA,VA|Rest], [VA,BR,BG,BA,VR,GR,GA,BV|Rest]).
mossa_s_2(vr8, [BV,BR,BG,BA,VR|Rest], [VR,BR,BG,BA,BV|Rest]).
mossa_s_2(va8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,VR,GR,GA,CV,CA,CG,CR,VA]).
mossa_s_2(vc8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,CV,GR,GA,VA,CA,CG,CR,VR]).
mossa_s_2(rb8, [BV,BR,BG,BA,VR|Rest], [BV,VR,BG,BA,BR|Rest]).
mossa_s_2(rv8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,CR,GR,GA,VA,CA,CG,VR,CV]).
mossa_s_2(rg8, [BV,BR,BG,BA,VR,GR|Rest], [BV,GR,BG,BA,VR,BR|Rest]).
mossa_s_2(rc8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,VR,CR,GA,VA,CA,CG,GR,CV]).
mossa_s_2(gb8, [BV,BR,BG,BA,VR,GR|Rest], [BV,GR,BG,BA,VR,BR|Rest]).
mossa_s_2(gr8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG|Rest], [BV,BR,BG,BA,VR,CG,GA,VA,CA,GR|Rest]).
mossa_s_2(ga8, [BV,BR,BG,BA,VR,GR,GA|Rest], [BV,BR,GA,BA,VR,GR,BG|Rest]).
mossa_s_2(gc8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG|Rest], [BV,BR,BG,BA,VR,GR,CG,VA,CA,GA|Rest]).
mossa_s_2(ab8, [BV,BR,BG,BA,VR,GR,GA|Rest], [BV,BR,BG,GA,VR,GR,BA|Rest]).
mossa_s_2(av8, [BV,BR,BG,BA,VR,GR,GA,VA|Rest], [BV,BR,BG,VA,VR,GR,GA,BA|Rest]).
mossa_s_2(ag8, [BV,BR,BG,BA,VR,GR,GA,VA,CA|Rest], [BV,BR,BG,BA,VR,GR,CA,VA,GA|Rest]).
mossa_s_2(ac8, [BV,BR,BG,BA,VR,GR,GA,VA,CA|Rest], [BV,BR,BG,BA,VR,GR,GA,CA,VA|Rest]).
mossa_s_2(cv8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,VR,GR,GA,VA,CV,CG,CR,CA]).
mossa_s_2(cr8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CV,CR]).
mossa_s_2(cg8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,VR,GR,GA,VA,CA,CR,CG,CV]).
mossa_s_2(ca8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,VR,GR,GA,VA,CG,CA,CR,CV]).

% Sequenze che attuano effettivamente le modifiche, anche sui vertici.
mossa(bv8,[[Bvr,V1],[Brg,V2],[Bga,V3],[Bav,V4]|VRest], [[Brg,Db],[Bga,Dc],[Bav,Dd],[Bvr,Da]|VRest],
	[[Bv,S1],[Br,S2]|SRest],	[[Br,Sb],[Bv,Sa]|SRest]):-
	cambia_dir(yz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [b,v,b,v3,b,v,b2,v3] %%%%
mossa(br8,[[Bvr,V1],[Brg,V2],[Bga,V3],[Bav,V4]|VRest], [[Brg,Db],[Bga,Dc],[Bav,Dd],[Bvr,Da]|VRest],
	[Bv,[Br,S1],[Bg,S2]|SRest],	[Bv,[Bg,Sb],[Br,Sa]|SRest]):-
	cambia_dir(xz,V1,Da), cambia_dir(yz,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [b,r,b,r3,b,r,b2,r3] %%%%
mossa(bg8,[[Bvr,V1],[Brg,V2],[Bga,V3],[Bav,V4]|VRest], [[Brg,Db],[Bga,Dc],[Bav,Dd],[Bvr,Da]|VRest],
	[Bv,Br,[Bg,S1],[Ba,S2]|SRest],	[Bv,Br,[Ba,Sb],[Bg,Sa]|SRest]):-
	cambia_dir(xz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [b,g,b,g3,b,g,b2,g3] %%%%
mossa(ba8,[[Bvr,V1],[Brg,V2],[Bga,V3],[Bav,V4]|VRest], [[Brg,Db],[Bga,Dc],[Bav,Dd],[Bvr,Da]|VRest],
	[[Bv,S1],Br,Bg,[Ba,S2]|SRest],	[[Ba,Sb],Br,Bg,[Bv,Sa]|SRest]):-
	cambia_dir(xz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(yz,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [b,a,b,a3,b,a,b2,a3] %%%%

mossa(vb8,[[Bvr,V1],Brg,Bga,[Bav,V2],[Cva,V3],Cag,Cgr,[Crv,V4]], 
	[[Bav,Db],Brg,Bga,[Cva,Dc],[Crv,Dd],Cag,Cgr,[Bvr,Da]],
	[[Bv,S1],Br,Bg,Ba,Vr,Gr,Ga,[Va,S2]|Rest],	[[Va,Sb],Br,Bg,Ba,Vr,Gr,Ga,[Bv,Sa]|Rest]):-
	cambia_dir(xy,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(xy,V3,Dc), cambia_dir(yz,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [v,b,v,b3,v,b,v2,b3] %%%%
mossa(vr8,[[Bvr,V1],Brg,Bga,[Bav,V2],[Cva,V3],Cag,Cgr,[Crv,V4]], 
	[[Bav,Db],Brg,Bga,[Cva,Dc],[Crv,Dd],Cag,Cgr,[Bvr,Da]],
	[[Bv,S1],Br,Bg,Ba,[Vr,S2]|Rest],	[[Vr,Sb],Br,Bg,Ba,[Bv,Sa]|Rest]):-
	cambia_dir(xz,V1,Da), cambia_dir(yz,V2,Db), cambia_dir(xy,V3,Dc), cambia_dir(yz,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [v,r,v,r3,v,r,v2,r3] %%%%
mossa(va8,[[Bvr,V1],Brg,Bga,[Bav,V2],[Cva,V3],Cag,Cgr,[Crv,V4]], 
	[[Bav,Db],Brg,Bga,[Cva,Dc],[Crv,Dd],Cag,Cgr,[Bvr,Da]],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,[Va,S1],Ca,Cg,Cr,[Cv,S2]],	[Bv,Br,Bg,Ba,Vr,Gr,Ga,[Cv,Sb],Ca,Cg,Cr,[Va,Sa]]):-
	cambia_dir(xy,V1,Da), cambia_dir(yz,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(yz,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [v,a,v,a3,v,a,v2,a3] %%%%
mossa(vc8,[[Bvr,V1],Brg,Bga,[Bav,V2],[Cva,V3],Cag,Cgr,[Crv,V4]], 
	[[Bav,Db],Brg,Bga,[Cva,Dc],[Crv,Dd],Cag,Cgr,[Bvr,Da]],
	[Bv,Br,Bg,Ba,[Vr,S1],Gr,Ga,Va,Ca,Cg,Cr,[Cv,S2]],	[Bv,Br,Bg,Ba,[Cv,Sb],Gr,Ga,Va,Ca,Cg,Cr,[Vr,Sa]]):-
	cambia_dir(xy,V1,Da), cambia_dir(yz,V2,Db), cambia_dir(xy,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [v,c,v,c3,v,c,v2,c3] %%%%

mossa(rb8,[[Bvr,V1],[Brg,V2],Bga,Bav,Cva,Cag,[Cgr,V3],[Crv,V4]], 
	[[Crv,Dd],[Bvr,Da],Bga,Bav,Cva,Cag,[Brg,Db],[Cgr,Dc]],
	[Bv,[Br,S1],Bg,Ba,[Vr,S2]|Rest],	[Bv,[Vr,Sb],Bg,Ba,[Br,Sa]|Rest]):-
	cambia_dir(xy,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [r,b,r,b3,r,b,r2,b3] %%%%
mossa(rv8,[[Bvr,V1],[Brg,V2],Bga,Bav,Cva,Cag,[Cgr,V3],[Crv,V4]], 
	[[Crv,Dd],[Bvr,Da],Bga,Bav,Cva,Cag,[Brg,Db],[Cgr,Dc]],
	[Bv,Br,Bg,Ba,[Vr,S1],Gr,Ga,Va,Ca,Cg,[Cr,S2],Cv],	[Bv,Br,Bg,Ba,[Cr,Sb],Gr,Ga,Va,Ca,Cg,[Vr,Sa],Cv]):-
	cambia_dir(yz,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [r,v,r,v3,r,v,r2,v3] %%%%
mossa(rg8,[[Bvr,V1],[Brg,V2],Bga,Bav,Cva,Cag,[Cgr,V3],[Crv,V4]], 
	[[Crv,Dd],[Bvr,Da],Bga,Bav,Cva,Cag,[Brg,Db],[Cgr,Dc]],
	[Bv,[Br,S1],Bg,Ba,Vr,[Gr,S2]|Rest],	[Bv,[Gr,Sb],Bg,Ba,Vr,[Br,Sa]|Rest]):-
	cambia_dir(yz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [r,g,r,g3,r,g,r2,g3] %%%%
mossa(rc8,[[Bvr,V1],[Brg,V2],Bga,Bav,Cva,Cag,[Cgr,V3],[Crv,V4]], 
	[[Crv,Dd],[Bvr,Da],Bga,Bav,Cva,Cag,[Brg,Db],[Cgr,Dc]],
	[Bv,Br,Bg,Ba,Vr,[Gr,S1],Ga,Va,Ca,Cg,[Cr,S2],Cv],	[Bv,Br,Bg,Ba,Vr,[Cr,Sb],Ga,Va,Ca,Cg,[Gr,Sa],Cv]):-
	cambia_dir(yz,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(xy,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [r,c,r,c3,r,c,r2,c3] %%%%

mossa(gb8,[Bvr,[Brg,V1],[Bga,V2],Bav,Cva,[Cag,V3],[Cgr,V4],Crv], 
	[Bvr,[Cgr,Dd],[Brg,Da],Bav,Cva,[Bga,Db],[Cag,Dc],Crv],
	[Bv,Br,[Bg,S1],Ba,Vr,[Gr,S2]|Rest],	[Bv,Br,[Gr,Sb],Ba,Vr,[Bg,Sa]|Rest]):-
	cambia_dir(xz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [g,b,g,b3,g,b,g2,b3] %%%%
mossa(gr8,[Bvr,[Brg,V1],[Bga,V2],Bav,Cva,[Cag,V3],[Cgr,V4],Crv], 
	[Bvr,[Cgr,Dd],[Brg,Da],Bav,Cva,[Bga,Db],[Cag,Dc],Crv],
	[Bv,Br,Bg,Ba,Vr,[Gr,S1],Ga,Va,Ca,[Cg,S2]|Rest],	[Bv,Br,Bg,Ba,Vr,[Cg,Sb],Ga,Va,Ca,[Gr,Sa]|Rest]):-
	cambia_dir(yz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [g,r,g,r3,g,r,g2,r3] %%%%
mossa(ga8,[Bvr,[Brg,V1],[Bga,V2],Bav,Cva,[Cag,V3],[Cgr,V4],Crv], 
	[Bvr,[Cgr,Dd],[Brg,Da],Bav,Cva,[Bga,Db],[Cag,Dc],Crv],
	[Bv,Br,[Bg,S1],Ba,Vr,Gr,[Ga,S2],Va,Ca,Cg,Cr,Cv],	[Bv,Br,[Ga,Sb],Ba,Vr,Gr,[Bg,Sa],Va,Ca,Cg,Cr,Cv]):-
	cambia_dir(yz,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [g,a,g,a3,g,a,g2,a3] %%%%
mossa(gc8,[Bvr,[Brg,V1],[Bga,V2],Bav,Cva,[Cag,V3],[Cgr,V4],Crv], 
	[Bvr,[Cgr,Dd],[Brg,Da],Bav,Cva,[Bga,Db],[Cag,Dc],Crv],
	[Bv,Br,Bg,Ba,Vr,Gr,[Ga,S1],Va,Ca,[Cg,S2]|Rest],	[Bv,Br,Bg,Ba,Vr,Gr,[Cg,Sb],Va,Ca,[Ga,Sa]|Rest]):-
	cambia_dir(yz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [g,c,g,c3,g,c,g2,c3] %%%%

mossa(ab8,[Bvr,Brg,[Bga,V1],[Bav,V2],[Cva,V3],[Cag,V4]|VRest], 
	[Bvr,Brg,[Cag,Dd],[Bga,Da],[Bav,Db],[Cva,Dc]|VRest],
	[Bv,Br,Bg,[Ba,S1],Vr,Gr,[Ga,S2]|SRest],	[Bv,Br,Bg,[Ga,Sb],Vr,Gr,[Ba,Sa]|SRest]):-
	cambia_dir(xy,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [a,b,a,b3,a,b,a2,b3] %%%%
mossa(av8,[Bvr,Brg,[Bga,V1],[Bav,V2],[Cva,V3],[Cag,V4]|VRest], 
	[Bvr,Brg,[Cag,Dd],[Bga,Da],[Bav,Db],[Cva,Dc]|VRest],
	[Bv,Br,Bg,[Ba,S1],Vr,Gr,Ga,[Va,S2]|SRest],	[Bv,Br,Bg,[Va,Sb],Vr,Gr,Ga,[Ba,Sa]|SRest]):-
	cambia_dir(yz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [a,v,a,v3,a,v,a2,v3] %%%%
mossa(ag8,[Bvr,Brg,[Bga,V1],[Bav,V2],[Cva,V3],[Cag,V4]|VRest], 
	[Bvr,Brg,[Cag,Dd],[Bga,Da],[Bav,Db],[Cva,Dc]|VRest],
	[Bv,Br,Bg,Ba,Vr,Gr,[Ga,S1],Va,[Ca,S2]|SRest],	[Bv,Br,Bg,Ba,Vr,Gr,[Ca,Sb],Va,[Ga,Sa]|SRest]):-
	cambia_dir(yz,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [a,g,a,g3,a,g,a2,g3] %%%%
mossa(ac8,[Bvr,Brg,[Bga,V1],[Bav,V2],[Cva,V3],[Cag,V4]|VRest], 
	[Bvr,Brg,[Cag,Dd],[Bga,Da],[Bav,Db],[Cva,Dc]|VRest],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,[Va,S1],[Ca,S2]|SRest],	[Bv,Br,Bg,Ba,Vr,Gr,Ga,[Ca,Sb],[Va,Sa]|SRest]):-
	cambia_dir(yz,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(xy,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [a,c,a,c3,a,c,a2,c3] %%%%

mossa(cv8,[Bvr,Brg,Bga,Bav,[Cva,V1],[Cag,V2],[Cgr,V3],[Crv,V4]],  
	[Bvr,Brg,Bga,Bav,[Cag,Db],[Cgr,Dc],[Crv,Dd],[Cva,Da]],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,[Ca,S1],Cg,Cr,[Cv,S2]],	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,[Cv,Sb],Cg,Cr,[Ca,Sa]]):-
	cambia_dir(yz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [c,v,c,v3,c,v,c2,v3] %%%%
mossa(cr8,[Bvr,Brg,Bga,Bav,[Cva,V1],[Cag,V2],[Cgr,V3],[Crv,V4]],  
	[Bvr,Brg,Bga,Bav,[Cag,Db],[Cgr,Dc],[Crv,Dd],[Cva,Da]],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,Ca,Cg,[Cr,S1],[Cv,S2]],	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,Ca,Cg,[Cv,Sb],[Cr,Sa]]):-
	cambia_dir(xz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(yz,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [c,r,c,r3,c,r,c2,r3] %%%%
mossa(cg8,[Bvr,Brg,Bga,Bav,[Cva,V1],[Cag,V2],[Cgr,V3],[Crv,V4]],  
	[Bvr,Brg,Bga,Bav,[Cag,Db],[Cgr,Dc],[Crv,Dd],[Cva,Da]],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,Ca,[Cg,S1],[Cr,S2],Cv],	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,Ca,[Cr,Sb],[Cg,Sa],Cv]):-
	cambia_dir(xz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [c,g,c,g3,c,g,c2,g3] %%%%
mossa(ca8,[Bvr,Brg,Bga,Bav,[Cva,V1],[Cag,V2],[Cgr,V3],[Crv,V4]],  
	[Bvr,Brg,Bga,Bav,[Cag,Db],[Cgr,Dc],[Crv,Dd],[Cva,Da]],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,[Ca,S1],[Cg,S2]|Rest],	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,[Cg,Sb],[Ca,Sa]|Rest]):-
	cambia_dir(xz,V1,Da), cambia_dir(yz,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [c,a,c,a3,c,a,c2,a3] %%%%

% Le seguenti sono regole fatte ad hoc per gli spigoli gi posizionati, dunque non generali
mossa_s_o(bvr4x4,1,[Bvr,Brg,Bga,[Bav,V1],Cva,Cag,Cgr,[Crv,V2]], [Bvr,Brg,Bga,[Bav,Da],Cva,Cag,Cgr,[Crv,Db]],
	[[Bv,y],[Br,O]|Rest], [[Bv,x],[Br,O1]|Rest]):- ruota_antiorario(V1,Da), ruota_orario(V2,Db), 
	cambia_dir(xz,O,O1). % [b3,v,b,v3,b3,v,b,v3,r,v3,r3,v,r,v3,r3,v], cambia [bv,br]
mossa_s_o(brg4x4,2,[[Bvr,V1],Brg,Bga,Bav,Cva,Cag,[Cgr,V2],Crv],  [[Bvr,Da],Brg,Bga,Bav,Cva,Cag,[Cgr,Db],Crv],
	[Bv,[Br,z],[Bg,O]|Rest], [Bv,[Br,x],[Bg,O1]|Rest]):- ruota_orario(V1,Da), ruota_antiorario(V2,Db),
	 cambia_dir(xy,O,O1). % [b3,r,b,r3,b3,r,b,r3,g,r3,g3,r,g,r3,g3,r], cambia [br,bg]
mossa_s_o(bga4x4,3,[Bvr,[Brg,V1],Bga,Bav,Cva,[Cag,V2],Cgr,Crv],  [Bvr,[Brg,Da],Bga,Bav,Cva,[Cag,Db],Cgr,Crv],
	[Bv,Br,[Bg,y],[Ba,O]|Rest], [Bv,Br,[Bg,x],[Ba,O1]|Rest]):- ruota_antiorario(V1,Da), ruota_orario(V2,Db),
	 cambia_dir(xz,O,O1). % [b3,g,b,g3,b3,g,b,g3,a,g3,a3,g,a,g3,a3,g], cambia [bg,ba]
mossa_s_o(abg4x4,4,[Bvr,[Brg,V1],Bga,[Bav,V2]|VRest],  [Bvr,[Brg,Da],Bga,[Bav,Db]|VRest],
	[Bv,Br,Bg,[Ba,z],Vr,Gr,[Ga,O]|SRest], [Bv,Br,Bg,[Ba,x],Vr,Gr,[Ga,O1]|SRest]):- ruota_orario(V1,Da),
	ruota_antiorario(V2,Db), cambia_dir(yz,O,O1). % [a3,b,a,b3,a3,b,a,b3,g,b3,g3,b,g,b3,g3,b], cambia [ba,ga]
mossa_s_o(agc4x4,5,[Bvr,Brg,[Bga,V1],Bav,Cva,Cag,[Cgr,V2],Crv],  [Bvr,Brg,[Bga,Da],Bav,Cva,Cag,[Cgr,Db],Crv],
	[Bv,Br,Bg,Ba,Vr,Gr,[Ga,z],Va,[Ca,O]|SRest], [Bv,Br,Bg,Ba,Vr,Gr,[Ga,y],Va,[Ca,O1]|SRest]):- 
	ruota_orario(V1,Da), ruota_antiorario(V2,Db), cambia_dir(xz,O,O1).
	%[a3,g,a,g3,a3,g,a,g3,c,g3,c3,g,c,g3,c3,g], cambia [ga,ca]
mossa_s_o(acv4x4,6,[Bvr,Brg,Bga,Bav,Cva,[Cag,V1],Cgr,[Crv,V2]],  [Bvr,Brg,Bga,Bav,Cva,[Cag,Da],Cgr,[Crv,Db]],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,[Va,O],[Ca,z]|SRest], [Bv,Br,Bg,Ba,Vr,Gr,Ga,[Va,O1],[Ca,x]|SRest]):- 
	ruota_orario(V2,Db),	ruota_antiorario(V1,Da), cambia_dir(yz,O,O1). 
	% [a3,c,a,c3,a3,c,a,c3,v,c3,v3,c,v,c3,v3,c], cambia [ca,va]
mossa_s_o(vac4x4,7,[Bvr,Brg,Bga,[Bav,V1],Cva,[Cag,V2]|Rest],  [Bvr,Brg,Bga,[Bav,Da],Cva,[Cag,Db]|Rest],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,[Va,z],Ca,Cg,Cr,[Cv,O]], [Bv,Br,Bg,Ba,Vr,Gr,Ga,[Va,y],Ca,Cg,Cr,[Cv,O1]]):- 
	ruota_orario(V2,Db), ruota_antiorario(V1,Da), cambia_dir(xy,O,O1). 
	% [v3,a,v,a3,v3,a,v,a3,c,a3,c3,a,c,a3,c3,a], cambia [va,cv]
mossa_s_o(vcr4x4,8,[Bvr,Brg,Bga,Bav,[Cva,V1],Cag,[Cgr,V2],Crv],  [Bvr,Brg,Bga,Bav,[Cva,Da],Cag,[Cgr,Db],Crv],
	[Bv,Br,Bg,Ba,[Vr,O],Gr,Ga,Va,Ca,Cg,Cr,[Cv,y]], [Bv,Br,Bg,Ba,[Vr,O1],Gr,Ga,Va,Ca,Cg,Cr,[Cv,x]]):- 
	ruota_orario(V1,Da), ruota_antiorario(V2,Db), cambia_dir(yz,O,O1). 
	%[v3,c,v,c3,v3,c,v,c3,r,c3,r3,c,r,c3,r3,c], cambia [cv,vr]
mossa_s_o(rvc4x4,9,[[Bvr,V1],Brg,Bga,Bav,[Cva,V2]|Rest],  [[Bvr,Da],Brg,Bga,Bav,[Cva,Db]|Rest],
	[Bv,Br,Bg,Ba,[Vr,z],Gr,Ga,Va,Ca,Cg,[Cr,O],Cv], [Bv,Br,Bg,Ba,[Vr,y],Gr,Ga,Va,Ca,Cg,[Cr,O1],Cv]):- 
	ruota_orario(V1,Da), ruota_antiorario(V2,Db), cambia_dir(xz,O,O1).
	% [r3,v,r,v3,r3,v,r,v3,c,v3,c3,v,c,v3,c3,v], cambia [vr,cr]
mossa_s_o(rcg4x4,10,[Bvr,Brg,Bga,Bav,Cva,[Cag,V1],Cgr,[Crv,V2]],  [Bvr,Brg,Bga,Bav,Cva,[Cag,Da],Cgr,[Crv,Db]],
	[Bv,Br,Bg,Ba,Vr,[Gr,O],Ga,Va,Ca,Cg,[Cr,z],Cv], [Bv,Br,Bg,Ba,Vr,[Gr,O1],Ga,Va,Ca,Cg,[Cr,x],Cv]):- 
	ruota_orario(V1,Da), ruota_antiorario(V2,Db), cambia_dir(yz,O,O1). 
	% [r3,c,r,c3,r3,c,r,c3,g,c3,g3,c,g,c3,g3,c], cambia [cr,gr]
mossa_s_o(grc4x4,11,[Bvr,[Brg,V1],Bga,Bav,Cva,Cag,Cgr,[Crv,V2]],  [Bvr,[Brg,Da],Bga,Bav,Cva,Cag,Cgr,[Crv,Db]],
	[Bv,Br,Bg,Ba,Vr,[Gr,z],Ga,Va,Ca,[Cg,O]|Rest], [Bv,Br,Bg,Ba,Vr,[Gr,y],Ga,Va,Ca,[Cg,O1]|Rest]):- 
	ruota_orario(V2,Db), ruota_antiorario(V1,Da), cambia_dir(xy,O,O1). 
	% [g3,r,g,r3,g3,r,g,r3,c,r3,c3,r,c,r3,c3,r], cambia [gr,cg]

% RUOTA_ORARIO e RUOTA_ANTIORARIO
ruota_orario(x,y):- !.
ruota_orario(y,z):- !.
ruota_orario(z,x).
ruota_antiorario(y,x):- !.
ruota_antiorario(z,y):- !.
ruota_antiorario(x,z).

% CAMBIA_DIR
cambia_dir(xy,z,z):- !. 
cambia_dir(xy,x,y):- !.
cambia_dir(xy,y,x).
cambia_dir(xz,y,y):- !.
cambia_dir(xz,x,z):- !.
cambia_dir(xz,z,x).
cambia_dir(yz,x,x):- !.
cambia_dir(yz,y,z):- !.
cambia_dir(yz,z,y).

% INIZIALIZZAZIONE
vertici_ko([[cag,z],[bvr,y],[cgr,y],[bav,z],[crv,z],[bga,y],[cva,y],[brg,z]]).
spigoli_ko([[ca,y],[gr,z],[vr,x],[bg,x],[br,y],[cg,y],[ba,y],[cv,y],[ga,x],[bv,y],[va,z],[cr,x]]).
% b,v2,r,g2,a,c,b3,v3,r3,a3,c2.  Per aggiustarli: c2,a,2,v,b,c3,a3,g2,r3,v2,b3.

% GO
go:- vertici_ko(V), spigoli_ko(S), trova_spigoli(V,Vn,S,0,1), nl,nl, write(V),nl,write(Vn), nl.

% TROVA_SPIGOLI:	incrementa la profondit ed il numero di spigoli che devono essere a posto.
trova_spigoli(V,Vout,Spigoli,12,1):- !, nl, nl, orienta_spigoli(V,Vout,Spigoli,1).
trova_spigoli(V,Vout,S,Giusti,Profondit_max):- posizione_spigoli(S,Sequenza,z,Giusti,Profondit_max,0), !, 
	conta_mosse(Sequenza,Numero_mosse), calcola_stato_spigoli(V,S,Sequenza,Vn,Sn), 
	spigoli_fuori_posto(Sn,FP,D),  n_primi_spigoli_a_posto(NGiusti,Sn), write('Primi '), write(NGiusti), 
	write(' spigoli giusti, dopo '), write(Numero_mosse), write(' mosse ('),	write(Sequenza), write('), '), write(D),
	write(' spigoli fuori posto, cio:'), nl, write(FP), write('; posizioni attuali:'), nl, write(Sn), nl,
	spigoli_ok(S_ok), write(S_ok), write('  il goal.'), nl, write(Vn),nl, trova_spigoli(Vn,Vout,Sn,NGiusti,1).
trova_spigoli(V,Vn,S,Giusti,Profondit_max):- 
	P is Profondit_max+1, write('profondit: '), Pr is P-1, write(Pr),nl, trova_spigoli(V,Vn,S,Giusti,P).

% POSIZIONE_SPIGOLI:	motore di ricerca.
% Cerca di trovare una sequenza di mosse che porti ad avere un numero minore di "Diversi" spigoli fuori posto.
posizione_spigoli(S,[],_,N,_,_):- n_primi_spigoli_a_posto(Giusti,S),  Giusti>N, !.	% ho trovato!
posizione_spigoli(_,_,_,_,Profondit_max,Profondit_max):- !, fail. % forzo il backtracking
posizione_spigoli(Spigoli,[Mossa|Sequenza],_,N,Profondit_max,Profondit):-
	mossa_s_2(Mossa,Spigoli,Sn), P is Profondit+1, posizione_spigoli(Sn,Sequenza,_,N,Profondit_max,P).

% CONTA_MOSSE
conta_mosse(Sequenza,Numero_mosse):- length(Sequenza,0,Numero_mosse).
length([],N,N).
length([_|T],Acc,Numero_mosse):- Acc1 is Acc+1, length(T,Acc1,Numero_mosse).

% SPIGOLI_FUORI_POSTO
spigoli_fuori_posto(Spigoli,FP,N):- spigoli_ok(S_ok), spigoli_fuori_posto(Spigoli,S_ok,FP,0,N).
spigoli_fuori_posto([],[],[],N,N).
spigoli_fuori_posto([[H,_]|T],[[H,_]|T1],L,Acc,N):-  !, spigoli_fuori_posto(T,T1,L,Acc,N).
spigoli_fuori_posto([[H,O]|T],[[H1,O1]|T1],[[[H,O],[H1,O1]]|L],Acc,N):- 
	Acc1 is Acc+1, spigoli_fuori_posto(T,T1,L,Acc1,N).

% N_SPIGOLI_FUORI_POSTO
n_spigoli_fuori_posto(Spigoli,N):- spigoli_ok(S_ok), n_spigoli_fuori_posto(Spigoli,S_ok,0,N).

n_spigoli_fuori_posto([],[],N,N).
n_spigoli_fuori_posto([[H,_]|T],[[H,_]|T1],Acc,N):- !, n_spigoli_fuori_posto(T,T1,Acc,N).
n_spigoli_fuori_posto([_|T],[_|T1],Acc,N):- Acc1 is Acc+1, n_spigoli_fuori_posto(T,T1,Acc1,N).

% N_PRIMI_SPIGOLI_A_POSTO
n_primi_spigoli_a_posto(N,Spigoli):- spigoli_ok(S_ok), n_primi_spigoli_a_posto(Spigoli,S_ok,0,N).

n_primi_spigoli_a_posto([[H,_]|T],[[H,_]|T1],Acc,N):- !, Acc1 is Acc+1, n_primi_spigoli_a_posto(T,T1,Acc1,N).
n_primi_spigoli_a_posto(_,_,N,N). % termina quando non ci sono pi spigoli giusti nei primi posti.

% CALCOLA_STATO_SPIGOLI
calcola_stato_spigoli(V,S,[],V,S).
calcola_stato_spigoli(V,S,[Mossa|Sequenza],Vn,Sn):- mossa(Mossa,V,V1,S,S1), 
	calcola_stato_spigoli(V1,S1,Sequenza,Vn,Sn).

% ORIENTA_SPIGOLI
orienta_spigoli(V,V,Spigoli,12):- nl, write('Spigoli tutti a posto:'), nl, write(Spigoli).
orienta_spigoli(V,Vout,Spigoli,N):- mossa_s_o(Mossa,N,V,Vn,Spigoli,Sn), write(N), write(' spigoli orientati, con '),
	write(Mossa), write('; prima:'), nl, write(Spigoli), write(' dopo:'), nl, write(Sn), nl,
	N1 is N+1, orienta_spigoli(Vn,Vout,Sn,N1).
orienta_spigoli(V,Vout,Spigoli,N):- N1 is N+1, orienta_spigoli(V,Vout,Spigoli,N1).

