% Spigoli3.pl

% Programma che partendo da una configurazione in cui tutti i pezzi sono fuori posto riesce a sistemare le
% posizioni degli spigoli. Rispetto a "Spigoli1.pl" ho modificato trova_spigoli: qui i primi 4 spigoli vengono posizionati 
% tramite le mosse singole.  Ottengo cos due vantaggi:
% il tempo di calcolo  ancora minore ed il numero di mosse si riduce notevolmente:
% Per arrivare al goal meno di 1 secondo in 12 (7+5) sequenze di mosse, pi 6 mosse singole, per un totale di 142
% mosse, contro 17 (14+3) sequenze = 160. Nel posizionare degli spigoli ho risparmiato 7*8-6=50 mosse.

% Si possono posizionare anche ulteriori spigoli utilizzando le mosse singole, per aumenta il tempo i calcolo:
% sono riuscito a mettere 9 spigoli con mosse singole: 17 + 2*8=33 (altre 29 mosse risparmiate) in 3 secondi.
% Per posizionare 12 spigoli con mosse singole: 25 minuti e 52 secondi.
% Il problema  che dal 5 spigolo potrebbero servire anche 4 mosse singole, anzich solo 3 per i primi 4 spigoli,
% inoltre per gli ultimi 2 spigoli 6 o 7 mosse ed  questo che allunga enormemente il tempo di calcolo.


% [[pezzo,direzione]]:
% b=bianco, v=verde, r=rosso, a=arancio, g=giallo, c=cobalto (blu).
% x direzione bianco-cobalto, y direzione verde-giallo, z direzione rosso-arancio.
% la prima lettera indica il colore rispetto cui  riferita la direzione.
vertici_ok([[bvr,x],[brg,x],[bga,x],[bav,x],[cva,x],[cag,x],[cgr,x],[crv,x]]).
%	        1	       2	     3	   4	 5	6          7          8
spigoli_ok([[bv,x],[br,x],[bg,x],[ba,x],[vr,y],[gr,y],[ga,y],[va,y],[ca,x],[cg,x],[cr,x],[cv,x]]).
%	         1	      2        3        4	        5	    6	 7        8	       9       10      11      12

% MOSSA
% mossa(X,Prec,Mossa,Vertici_in,Vertici_out,Spigoli_in,Spigoli_out). 
% X  il nome della faccia che viene ruotata in senso orario, Prec  la faccia mossa precedentemente,
% Mossa indica di quanto ruotare.
% Mosse singole necessarie per ottenere le modifiche effettive anche dei vertici e degli orientamenti di tutti i pezzi.
mossa(b,Prec,b1,[[V1,D1],[V2,D2],[V3,D3],[V4,D4]|Rest_v],  [[V4,Dd],[V1,Da],[V2,Db],[V3,Dc]|Rest_v],
	[[S1,T1],[S2,T2],[S3,T3],[S4,T4]|Rest_s],  [[S4,Td],[S1,Ta],[S2,Tb],[S3,Tc]|Rest_s]) :-	Prec\==b,
	cambia_dir(yz,D1,Da),cambia_dir(yz,D2,Db),cambia_dir(yz,D3,Dc),cambia_dir(yz,D4,Dd),
	cambia_dir(yz,T1,Ta),cambia_dir(yz,T2,Tb),cambia_dir(yz,T3,Tc),cambia_dir(yz,T4,Td).
mossa(v,Prec,v1,[[V1,D1],A,B,[V4,D4],[V5,D5],C,D,[V8,D8]],  [[V8,Dd],A,B,[V1,Da],[V4,Db],C,D,[V5,Dc]],
	[[S1,T1],E,F,G,[S5,T5],H,I,[S8,T8],J,K,L,[S12,T12]],  [[S5,Tb],E,F,G,[S12,Td],H,I,[S1,Ta],J,K,L,[S8,Tc]]) :-
	Prec\==v, cambia_dir(xz,D1,Da),cambia_dir(xz,D4,Db),cambia_dir(xz,D5,Dc),cambia_dir(xz,D8,Dd),
	cambia_dir(xz,T1,Ta),cambia_dir(xz,T5,Tb),cambia_dir(xz,T8,Tc),cambia_dir(xz,T12,Td).
mossa(r,Prec,r1,[[V1,D1],[V2,D2],A,B,C,D,[V7,D7],[V8,D8]],  [[V2,Db],[V7,Dc],A,B,C,D,[V8,Dd],[V1,Da]],
	[E,[S2,T2],F,G,[S5,T5],[S6,T6],H,I,J,K,[S11,T11],L],  [E,[S6,Tc],F,G,[S2,Ta],[S11,Td],H,I,J,K,[S5,Tb],L]) :-
	Prec\==r, cambia_dir(xy,D1,Da),cambia_dir(xy,D2,Db),cambia_dir(xy,D7,Dc),cambia_dir(xy,D8,Dd),
	cambia_dir(xy,T2,Ta),cambia_dir(xy,T5,Tb),cambia_dir(xy,T6,Tc),cambia_dir(xy,T11,Td).
mossa(g,Prec,g1,[A,[V2,D2],[V3,D3],B,C,[V6,D6],[V7,D7],D],  [A,[V3,Db],[V6,Dc],B,C,[V7,Dd],[V2,Da],D],
	[E,F,[S3,T3],G,H,[S6,T6],[S7,T7],I,J,[S10,T10]|Rest_s],  
	[E,F,[S7,Tc],G,H,[S3,Ta],[S10,Td],I,J,[S6,Tb]|Rest_s]) :- Prec\==g,
	cambia_dir(xz,D2,Da),cambia_dir(xz,D3,Db),cambia_dir(xz,D6,Dc),cambia_dir(xz,D7,Dd),
	cambia_dir(xz,T3,Ta),cambia_dir(xz,T6,Tb),cambia_dir(xz,T7,Tc),cambia_dir(xz,T10,Td).
mossa(a,Prec,a1,[A,B,[V3,D3],[V4,D4],[V5,D5],[V6,D6]|Rest_v],  [A,B,[V4,Db],[V5,Dc],[V6,Dd],[V3,Da]|Rest_v],
	[E,F,G,[S4,T4],H,I,[S7,T7],[S8,T8],[S9,T9],J,K,L],  [E,F,G,[S8,Tc],H,I,[S4,Ta],[S9,Td],[S7,Tb],J,K,L]) :-
	Prec\==a,
	cambia_dir(xy,D3,Da),cambia_dir(xy,D4,Db),cambia_dir(xy,D5,Dc),cambia_dir(xy,D6,Dd),
	cambia_dir(xy,T4,Ta),cambia_dir(xy,T7,Tb),cambia_dir(xy,T8,Tc),cambia_dir(xy,T9,Td).
mossa(c,Prec,c1,[A,B,C,D,[V5,D5],[V6,D6],[V7,D7],[V8,D8]],  [A,B,C,D,[V8,Dd],[V5,Da],[V6,Db],[V7,Dc]],
	[E,F,G,H,I,J,K,L,[S9,T9],[S10,T10],[S11,T11],[S12,T12]],   
	[E,F,G,H,I,J,K,L,[S12,Td],[S9,Ta],[S10,Tb],[S11,Tc]]) :- Prec\==c,
	cambia_dir(yz,D5,Da),cambia_dir(yz,D6,Db),cambia_dir(yz,D7,Dc),cambia_dir(yz,D8,Dd),
	cambia_dir(yz,T9,Ta),cambia_dir(yz,T10,Tb),cambia_dir(yz,T11,Tc),cambia_dir(yz,T12,Td).

mossa(b,Prec,b2,[V1,V2,V3,V4|Rest_v],  [V3,V4,V1,V2|Rest_v],[S1,S2,S3,S4|Rest_s],  [S3,S4,S1,S2|Rest_s]) :-
	Prec\==b.
mossa(b,Prec,b3,[[V1,D1],[V2,D2],[V3,D3],[V4,D4]|Rest_v],  [[V2,Db],[V3,Dc],[V4,Dd],[V1,Da]|Rest_v],
	[[S1,T1],[S2,T2],[S3,T3],[S4,T4]|Rest_s],  [[S2,Tb],[S3,Tc],[S4,Td],[S1,Ta]|Rest_s]) :-
	Prec\==b, cambia_dir(yz,D1,Da),cambia_dir(yz,D2,Db),cambia_dir(yz,D3,Dc),cambia_dir(yz,D4,Dd),
	cambia_dir(yz,T1,Ta),cambia_dir(yz,T2,Tb),cambia_dir(yz,T3,Tc),cambia_dir(yz,T4,Td).
mossa(v,Prec,v2,[V1,A,B,V4,V5,C,D,V8],  [V5,A,B,V8,V1,C,D,V4],[S1,E,F,G,S5,H,I,S8,J,K,L,S12], 
	[S12,E,F,G,S8,H,I,S5,J,K,L,S1]) :- Prec\==v.
mossa(v,Prec,v3,[[V1,D1],A,B,[V4,D4],[V5,D5],C,D,[V8,D8]],  [[V4,Db],A,B,[V5,Dc],[V8,Dd],C,D,[V1,Da]],
	[[S1,T1],E,F,G,[S5,T5],H,I,[S8,T8],J,K,L,[S12,T12]],  [[S8,Tc],E,F,G,[S1,Ta],H,I,[S12,Td],J,K,L,[S5,Tb]]) :-
	Prec\==v, cambia_dir(xz,D1,Da),cambia_dir(xz,D4,Db),cambia_dir(xz,D5,Dc),cambia_dir(xz,D8,Dd),
	cambia_dir(xz,T1,Ta),cambia_dir(xz,T5,Tb),cambia_dir(xz,T8,Tc),cambia_dir(xz,T12,Td).
mossa(r,Prec,r2,[V1,V2,A,B,C,D,V7,V8],  [V7,V8,A,B,C,D,V1,V2],
	[E,S2,F,G,S5,S6,H,I,J,K,S11,L],  [E,S11,F,G,S6,S5,H,I,J,K,S2,L]) :- Prec\==r.
mossa(r,Prec,r3,[[V1,D1],[V2,D2],A,B,C,D,[V7,D7],[V8,D8]],  [[V8,Dd],[V1,Da],A,B,C,D,[V2,Db],[V7,Dc]],
	[E,[S2,T2],F,G,[S5,T5],[S6,T6],H,I,J,K,[S11,T11],L],  [E,[S5,Tb],F,G,[S11,Td],[S2,Ta],H,I,J,K,[S6,Tc],L]) :-
	Prec\==r, cambia_dir(xy,D1,Da),cambia_dir(xy,D2,Db),cambia_dir(xy,D7,Dc),cambia_dir(xy,D8,Dd),
	cambia_dir(xy,T2,Ta),cambia_dir(xy,T5,Tb),cambia_dir(xy,T6,Tc),cambia_dir(xy,T11,Td).
mossa(g,Prec,g2,[A,V2,V3,B,C,V6,V7,D],  [A,V6,V7,B,C,V2,V3,D],
	[E,F,S3,G,H,S6,S7,I,J,S10,K,L],  [E,F,S10,G,H,S7,S6,I,J,S3,K,L]) :- Prec\==r.
mossa(g,Prec,g3,[A,[V2,D2],[V3,D3],B,C,[V6,D6],[V7,D7],D],  [A,[V7,Dd],[V2,Da],B,C,[V3,Db],[V6,Dc],D],
	[E,F,[S3,T3],G,H,[S6,T6],[S7,T7],I,J,[S10,T10]|Rest_s],
	[E,F,[S6,Tb],G,H,[S10,Td],[S3,Ta],I,J,[S7,Tc]|Rest_s]) :- Prec\==g,
	cambia_dir(xz,D2,Da),cambia_dir(xz,D3,Db),cambia_dir(xz,D6,Dc),cambia_dir(xz,D7,Dd),
	cambia_dir(xz,T3,Ta),cambia_dir(xz,T6,Tb),cambia_dir(xz,T7,Tc),cambia_dir(xz,T10,Td).
mossa(a,Prec,a2,[A,B,V3,V4,V5,V6|Rest_v],  [A,B,V5,V6,V3,V4|Rest_v],
	[E,F,G,S4,H,I,S7,S8,S9,J,K,L],  [E,F,G,S9,H,I,S8,S7,S4,J,K,L]) :- Prec\==a.
mossa(a,Prec,a3,[A,B,[V3,D3],[V4,D4],[V5,D5],[V6,D6]|Rest_v],  [A,B,[V6,Dd],[V3,Da],[V4,Db],[V5,Dc]|Rest_v],
	[E,F,G,[S4,T4],H,I,[S7,T7],[S8,T8],[S9,T9],J,K,L],  [E,F,G,[S7,Tb],H,I,[S9,Td],[S4,Ta],[S8,Tc],J,K,L]) :-
	Prec\==a,
	cambia_dir(xy,D3,Da),cambia_dir(xy,D4,Db),cambia_dir(xy,D5,Dc),cambia_dir(xy,D6,Dd),
	cambia_dir(xy,T4,Ta),cambia_dir(xy,T7,Tb),cambia_dir(xy,T8,Tc),cambia_dir(xy,T9,Td).
mossa(c,Prec,c2,[A,B,C,D,V5,V6,V7,V8],  [A,B,C,D,V7,V8,V5,V6],
	[E,F,G,H,I,J,K,L,S9,S10,S11,S12],   [E,F,G,H,I,J,K,L,S11,S12,S9,S10]) :- Prec\==c.
mossa(c,Prec,c3,[A,B,C,D,[V5,D5],[V6,D6],[V7,D7],[V8,D8]],  [A,B,C,D,[V6,Db],[V7,Dc],[V8,Dd],[V5,Da]],
	[E,F,G,H,I,J,K,L,[S9,T9],[S10,T10],[S11,T11],[S12,T12]],
	[E,F,G,H,I,J,K,L,[S10,Tb],[S11,Tc],[S12,Td],[S9,Ta]]) :-
	Prec\==c, cambia_dir(yz,D5,Da),cambia_dir(yz,D6,Db),cambia_dir(yz,D7,Dc),cambia_dir(yz,D8,Dd),
	cambia_dir(yz,T9,Ta),cambia_dir(yz,T10,Tb),cambia_dir(yz,T11,Tc),cambia_dir(yz,T12,Td).

% Mosse singole utilizzate per la ricerca: sono semplici e veloci.
mossa_s(b,Prec,b1, [S1,S2,S3,S4|Rest_s],  [S4,S1,S2,S3|Rest_s]):- Prec\==b.
mossa_s(v,Prec,v1, [S1,E,F,G,S5,H,I,S8,J,K,L,S12], [S5,E,F,G,S12,H,I,S1,J,K,L,S8]):- Prec\==v.
mossa_s(r,Prec,r1, [E,S2,F,G,S5,S6,H,I,J,K,S11,L],  [E,S6,F,G,S2,S11,H,I,J,K,S5,L]):- Prec\==r.
mossa_s(g,Prec,g1, [E,F,S3,G,H,S6,S7,I,J,S10|Rest_s],  [E,F,S7,G,H,S3,S10,I,J,S6|Rest_s]):- Prec\==g.
mossa_s(a,Prec,a1, [E,F,G,S4,H,I,S7,S8,S9,J,K,L],  [E,F,G,S8,H,I,S4,S9,S7,J,K,L]):- Prec\==a.
mossa_s(c,Prec,c1, [E,F,G,H,I,J,K,L,S9,S10,S11,S12],   [E,F,G,H,I,J,K,L,S12,S9,S10,S11]):- Prec\==c.
mossa_s(b,Prec,b3, [S1,S2,S3,S4|Rest_s],  [S2,S3,S4,S1|Rest_s]) :- Prec\==b.
mossa_s(v,Prec,v3, [S1,E,F,G,S5,H,I,S8,J,K,L,S12],  [S8,E,F,G,S1,H,I,S12,J,K,L,S5]):- Prec\==v.
mossa_s(r,Prec,r3, [E,S2,F,G,S5,S6,H,I,J,K,S11,L],  [E,S5,F,G,S11,S2,H,I,J,K,S6,L]):- Prec\==r.
mossa_s(g,Prec,g3, [E,F,S3,G,H,S6,S7,I,J,S10|Rest_s],  [E,F,S6,G,H,S10,S3,I,J,S7|Rest_s]):- Prec\==g.
mossa_s(a,Prec,a3, [E,F,G,S4,H,I,S7,S8,S9,J,K,L],  [E,F,G,S7,H,I,S9,S4,S8,J,K,L]) :- Prec\==a.
mossa_s(c,Prec,c3, [E,F,G,H,I,J,K,L,S9,S10,S11,S12],   [E,F,G,H,I,J,K,L,S10,S11,S12,S9]) :- Prec\==c.
mossa_s(b,Prec,b2, [S1,S2,S3,S4|Rest_s],  [S3,S4,S1,S2|Rest_s]) :- Prec\==b.
mossa_s(v,Prec,v2, [S1,E,F,G,S5,H,I,S8,J,K,L,S12],  [S12,E,F,G,S8,H,I,S5,J,K,L,S1]) :- Prec\==v.
mossa_s(r,Prec,r2, [E,S2,F,G,S5,S6,H,I,J,K,S11,L],  [E,S11,F,G,S6,S5,H,I,J,K,S2,L]) :- Prec\==r.
mossa_s(g,Prec,g2, [E,F,S3,G,H,S6,S7,I,J,S10,K,L],  [E,F,S10,G,H,S7,S6,I,J,S3,K,L]) :- Prec\==r.
mossa_s(a,Prec,a2, [E,F,G,S4,H,I,S7,S8,S9,J,K,L],  [E,F,G,S9,H,I,S8,S7,S4,J,K,L]) :- Prec\==a.
mossa_s(c,Prec,c2, [E,F,G,H,I,J,K,L,S9,S10,S11,S12], [E,F,G,H,I,J,K,L,S11,S12,S9,S10]) :- Prec\==c.

% Sequenze utilizzate per la ricerca: sono semplici e veloci.
mossa_s_2(bv8, [BV,BR|Rest], [BR,BV|Rest]). % Sequenza: [b,v,b,v3,b,v,b2,v3]
mossa_s_2(br8, [BV,BR,BG|Rest], [BV,BG,BR|Rest]).
mossa_s_2(bg8, [BV,BR,BG,BA|Rest], [BV,BR,BA,BG|Rest]).
mossa_s_2(ba8, [BV,BR,BG,BA|Rest], [BA,BR,BG,BV|Rest]).
mossa_s_2(vb8, [BV,BR,BG,BA,VR,GR,GA,VA|Rest], [VA,BR,BG,BA,VR,GR,GA,BV|Rest]).
mossa_s_2(vr8, [BV,BR,BG,BA,VR|Rest], [VR,BR,BG,BA,BV|Rest]).
mossa_s_2(va8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,VR,GR,GA,CV,CA,CG,CR,VA]).
mossa_s_2(vc8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,CV,GR,GA,VA,CA,CG,CR,VR]).
mossa_s_2(rb8, [BV,BR,BG,BA,VR|Rest], [BV,VR,BG,BA,BR|Rest]).
mossa_s_2(rv8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,CR,GR,GA,VA,CA,CG,VR,CV]).
mossa_s_2(rg8, [BV,BR,BG,BA,VR,GR|Rest], [BV,GR,BG,BA,VR,BR|Rest]).
mossa_s_2(rc8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,VR,CR,GA,VA,CA,CG,GR,CV]).
mossa_s_2(gb8, [BV,BR,BG,BA,VR,GR|Rest], [BV,GR,BG,BA,VR,BR|Rest]).
mossa_s_2(gr8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG|Rest], [BV,BR,BG,BA,VR,CG,GA,VA,CA,GR|Rest]).
mossa_s_2(ga8, [BV,BR,BG,BA,VR,GR,GA|Rest], [BV,BR,GA,BA,VR,GR,BG|Rest]).
mossa_s_2(gc8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG|Rest], [BV,BR,BG,BA,VR,GR,CG,VA,CA,GA|Rest]).
mossa_s_2(ab8, [BV,BR,BG,BA,VR,GR,GA|Rest], [BV,BR,BG,GA,VR,GR,BA|Rest]).
mossa_s_2(av8, [BV,BR,BG,BA,VR,GR,GA,VA|Rest], [BV,BR,BG,VA,VR,GR,GA,BA|Rest]).
mossa_s_2(ag8, [BV,BR,BG,BA,VR,GR,GA,VA,CA|Rest], [BV,BR,BG,BA,VR,GR,CA,VA,GA|Rest]).
mossa_s_2(ac8, [BV,BR,BG,BA,VR,GR,GA,VA,CA|Rest], [BV,BR,BG,BA,VR,GR,GA,CA,VA|Rest]).
mossa_s_2(cv8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,VR,GR,GA,VA,CV,CG,CR,CA]).
mossa_s_2(cr8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CV,CR]).
mossa_s_2(cg8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,VR,GR,GA,VA,CA,CR,CG,CV]).
mossa_s_2(ca8, [BV,BR,BG,BA,VR,GR,GA,VA,CA,CG,CR,CV], [BV,BR,BG,BA,VR,GR,GA,VA,CG,CA,CR,CV]).

% Sequenze necessarie per ottenere le modifiche effettive anche dei vertici e degli orientamenti di tutti i pezzi.
mossa_s_2t(bv8,[[Bvr,V1],[Brg,V2],[Bga,V3],[Bav,V4]|VRest], [[Brg,Db],[Bga,Dc],[Bav,Dd],[Bvr,Da]|VRest],
	[[Bv,S1],[Br,S2]|SRest],	[[Br,Sb],[Bv,Sa]|SRest]):-
	cambia_dir(yz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [b,v,b,v3,b,v,b2,v3] 
mossa_s_2t(br8,[[Bvr,V1],[Brg,V2],[Bga,V3],[Bav,V4]|VRest], [[Brg,Db],[Bga,Dc],[Bav,Dd],[Bvr,Da]|VRest],
	[Bv,[Br,S1],[Bg,S2]|SRest],	[Bv,[Bg,Sb],[Br,Sa]|SRest]):-
	cambia_dir(xz,V1,Da), cambia_dir(yz,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [b,r,b,r3,b,r,b2,r3] 
mossa_s_2t(bg8,[[Bvr,V1],[Brg,V2],[Bga,V3],[Bav,V4]|VRest], [[Brg,Db],[Bga,Dc],[Bav,Dd],[Bvr,Da]|VRest],
	[Bv,Br,[Bg,S1],[Ba,S2]|SRest],	[Bv,Br,[Ba,Sb],[Bg,Sa]|SRest]):-
	cambia_dir(xz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [b,g,b,g3,b,g,b2,g3] 
mossa_s_2t(ba8,[[Bvr,V1],[Brg,V2],[Bga,V3],[Bav,V4]|VRest], [[Brg,Db],[Bga,Dc],[Bav,Dd],[Bvr,Da]|VRest],
	[[Bv,S1],Br,Bg,[Ba,S2]|SRest],	[[Ba,Sb],Br,Bg,[Bv,Sa]|SRest]):-
	cambia_dir(xz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(yz,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [b,a,b,a3,b,a,b2,a3] 

mossa_s_2t(vb8,[[Bvr,V1],Brg,Bga,[Bav,V2],[Cva,V3],Cag,Cgr,[Crv,V4]],
	[[Bav,Db],Brg,Bga,[Cva,Dc],[Crv,Dd],Cag,Cgr,[Bvr,Da]], [[Bv,S1],Br,Bg,Ba,Vr,Gr,Ga,[Va,S2]|Rest],	[[Va,Sb],Br,Bg,Ba,Vr,Gr,Ga,[Bv,Sa]|Rest]):- 
	cambia_dir(xy,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(xy,V3,Dc),cambia_dir(yz,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb). % [v,b,v,b3,v,b,v2,b3] 
mossa_s_2t(vr8,[[Bvr,V1],Brg,Bga,[Bav,V2],[Cva,V3],Cag,Cgr,[Crv,V4]], 
	[[Bav,Db],Brg,Bga,[Cva,Dc],[Crv,Dd],Cag,Cgr,[Bvr,Da]],
	[[Bv,S1],Br,Bg,Ba,[Vr,S2]|Rest],	[[Vr,Sb],Br,Bg,Ba,[Bv,Sa]|Rest]):-
	cambia_dir(xz,V1,Da), cambia_dir(yz,V2,Db), cambia_dir(xy,V3,Dc), cambia_dir(yz,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [v,r,v,r3,v,r,v2,r3] 
mossa_s_2t(va8,[[Bvr,V1],Brg,Bga,[Bav,V2],[Cva,V3],Cag,Cgr,[Crv,V4]], 
	[[Bav,Db],Brg,Bga,[Cva,Dc],[Crv,Dd],Cag,Cgr,[Bvr,Da]],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,[Va,S1],Ca,Cg,Cr,[Cv,S2]],	[Bv,Br,Bg,Ba,Vr,Gr,Ga,[Cv,Sb],Ca,Cg,Cr,[Va,Sa]]):-
	cambia_dir(xy,V1,Da), cambia_dir(yz,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(yz,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [v,a,v,a3,v,a,v2,a3] 
mossa_s_2t(vc8,[[Bvr,V1],Brg,Bga,[Bav,V2],[Cva,V3],Cag,Cgr,[Crv,V4]], 
	[[Bav,Db],Brg,Bga,[Cva,Dc],[Crv,Dd],Cag,Cgr,[Bvr,Da]],
	[Bv,Br,Bg,Ba,[Vr,S1],Gr,Ga,Va,Ca,Cg,Cr,[Cv,S2]],	[Bv,Br,Bg,Ba,[Cv,Sb],Gr,Ga,Va,Ca,Cg,Cr,[Vr,Sa]]):-
	cambia_dir(xy,V1,Da), cambia_dir(yz,V2,Db), cambia_dir(xy,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [v,c,v,c3,v,c,v2,c3] 

mossa_s_2t(rb8,[[Bvr,V1],[Brg,V2],Bga,Bav,Cva,Cag,[Cgr,V3],[Crv,V4]], 
	[[Crv,Dd],[Bvr,Da],Bga,Bav,Cva,Cag,[Brg,Db],[Cgr,Dc]],
	[Bv,[Br,S1],Bg,Ba,[Vr,S2]|Rest],	[Bv,[Vr,Sb],Bg,Ba,[Br,Sa]|Rest]):-
	cambia_dir(xy,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [r,b,r,b3,r,b,r2,b3] 
mossa_s_2t(rv8,[[Bvr,V1],[Brg,V2],Bga,Bav,Cva,Cag,[Cgr,V3],[Crv,V4]], 
	[[Crv,Dd],[Bvr,Da],Bga,Bav,Cva,Cag,[Brg,Db],[Cgr,Dc]],
	[Bv,Br,Bg,Ba,[Vr,S1],Gr,Ga,Va,Ca,Cg,[Cr,S2],Cv],	[Bv,Br,Bg,Ba,[Cr,Sb],Gr,Ga,Va,Ca,Cg,[Vr,Sa],Cv]):-
	cambia_dir(yz,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [r,v,r,v3,r,v,r2,v3] 
mossa_s_2t(rg8,[[Bvr,V1],[Brg,V2],Bga,Bav,Cva,Cag,[Cgr,V3],[Crv,V4]], 
	[[Crv,Dd],[Bvr,Da],Bga,Bav,Cva,Cag,[Brg,Db],[Cgr,Dc]],
	[Bv,[Br,S1],Bg,Ba,Vr,[Gr,S2]|Rest],	[Bv,[Gr,Sb],Bg,Ba,Vr,[Br,Sa]|Rest]):-
	cambia_dir(yz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [r,g,r,g3,r,g,r2,g3] 
mossa_s_2t(rc8,[[Bvr,V1],[Brg,V2],Bga,Bav,Cva,Cag,[Cgr,V3],[Crv,V4]], 
	[[Crv,Dd],[Bvr,Da],Bga,Bav,Cva,Cag,[Brg,Db],[Cgr,Dc]],
	[Bv,Br,Bg,Ba,Vr,[Gr,S1],Ga,Va,Ca,Cg,[Cr,S2],Cv],	[Bv,Br,Bg,Ba,Vr,[Cr,Sb],Ga,Va,Ca,Cg,[Gr,Sa],Cv]):-
	cambia_dir(yz,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(xy,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [r,c,r,c3,r,c,r2,c3] 

mossa_s_2t(gb8,[Bvr,[Brg,V1],[Bga,V2],Bav,Cva,[Cag,V3],[Cgr,V4],Crv], 
	[Bvr,[Cgr,Dd],[Brg,Da],Bav,Cva,[Bga,Db],[Cag,Dc],Crv],
	[Bv,Br,[Bg,S1],Ba,Vr,[Gr,S2]|Rest],	[Bv,Br,[Gr,Sb],Ba,Vr,[Bg,Sa]|Rest]):-
	cambia_dir(xz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [g,b,g,b3,g,b,g2,b3] 
mossa_s_2t(gr8,[Bvr,[Brg,V1],[Bga,V2],Bav,Cva,[Cag,V3],[Cgr,V4],Crv], 
	[Bvr,[Cgr,Dd],[Brg,Da],Bav,Cva,[Bga,Db],[Cag,Dc],Crv],
	[Bv,Br,Bg,Ba,Vr,[Gr,S1],Ga,Va,Ca,[Cg,S2]|Rest],	[Bv,Br,Bg,Ba,Vr,[Cg,Sb],Ga,Va,Ca,[Gr,Sa]|Rest]):-
	cambia_dir(yz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [g,r,g,r3,g,r,g2,r3] 
mossa_s_2t(ga8,[Bvr,[Brg,V1],[Bga,V2],Bav,Cva,[Cag,V3],[Cgr,V4],Crv], 
	[Bvr,[Cgr,Dd],[Brg,Da],Bav,Cva,[Bga,Db],[Cag,Dc],Crv],
	[Bv,Br,[Bg,S1],Ba,Vr,Gr,[Ga,S2],Va,Ca,Cg,Cr,Cv],	[Bv,Br,[Ga,Sb],Ba,Vr,Gr,[Bg,Sa],Va,Ca,Cg,Cr,Cv]):-
	cambia_dir(yz,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [g,a,g,a3,g,a,g2,a3] 
mossa_s_2t(gc8,[Bvr,[Brg,V1],[Bga,V2],Bav,Cva,[Cag,V3],[Cgr,V4],Crv], 
	[Bvr,[Cgr,Dd],[Brg,Da],Bav,Cva,[Bga,Db],[Cag,Dc],Crv],
	[Bv,Br,Bg,Ba,Vr,Gr,[Ga,S1],Va,Ca,[Cg,S2]|Rest],	[Bv,Br,Bg,Ba,Vr,Gr,[Cg,Sb],Va,Ca,[Ga,Sa]|Rest]):-
	cambia_dir(yz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(xz,S1,Sa), cambia_dir(xz,S2,Sb).	% [g,c,g,c3,g,c,g2,c3] 

mossa_s_2t(ab8,[Bvr,Brg,[Bga,V1],[Bav,V2],[Cva,V3],[Cag,V4]|VRest], 
	[Bvr,Brg,[Cag,Dd],[Bga,Da],[Bav,Db],[Cva,Dc]|VRest],
	[Bv,Br,Bg,[Ba,S1],Vr,Gr,[Ga,S2]|SRest],	[Bv,Br,Bg,[Ga,Sb],Vr,Gr,[Ba,Sa]|SRest]):-
	cambia_dir(xy,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [a,b,a,b3,a,b,a2,b3] 
mossa_s_2t(av8,[Bvr,Brg,[Bga,V1],[Bav,V2],[Cva,V3],[Cag,V4]|VRest], 
	[Bvr,Brg,[Cag,Dd],[Bga,Da],[Bav,Db],[Cva,Dc]|VRest],
	[Bv,Br,Bg,[Ba,S1],Vr,Gr,Ga,[Va,S2]|SRest],	[Bv,Br,Bg,[Va,Sb],Vr,Gr,Ga,[Ba,Sa]|SRest]):-
	cambia_dir(yz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [a,v,a,v3,a,v,a2,v3] 
mossa_s_2t(ag8,[Bvr,Brg,[Bga,V1],[Bav,V2],[Cva,V3],[Cag,V4]|VRest], 
	[Bvr,Brg,[Cag,Dd],[Bga,Da],[Bav,Db],[Cva,Dc]|VRest],
	[Bv,Br,Bg,Ba,Vr,Gr,[Ga,S1],Va,[Ca,S2]|SRest],	[Bv,Br,Bg,Ba,Vr,Gr,[Ca,Sb],Va,[Ga,Sa]|SRest]):-
	cambia_dir(yz,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [a,g,a,g3,a,g,a2,g3] 
mossa_s_2t(ac8,[Bvr,Brg,[Bga,V1],[Bav,V2],[Cva,V3],[Cag,V4]|VRest], 
	[Bvr,Brg,[Cag,Dd],[Bga,Da],[Bav,Db],[Cva,Dc]|VRest],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,[Va,S1],[Ca,S2]|SRest],	[Bv,Br,Bg,Ba,Vr,Gr,Ga,[Ca,Sb],[Va,Sa]|SRest]):-
	cambia_dir(yz,V1,Da), cambia_dir(xz,V2,Db), cambia_dir(xy,V3,Dc), cambia_dir(xz,V4,Dd),
	cambia_dir(xy,S1,Sa), cambia_dir(xy,S2,Sb).	% [a,c,a,c3,a,c,a2,c3] 

mossa_s_2t(cv8,[Bvr,Brg,Bga,Bav,[Cva,V1],[Cag,V2],[Cgr,V3],[Crv,V4]],  
	[Bvr,Brg,Bga,Bav,[Cag,Db],[Cgr,Dc],[Crv,Dd],[Cva,Da]],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,[Ca,S1],Cg,Cr,[Cv,S2]],	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,[Cv,Sb],Cg,Cr,[Ca,Sa]]):-
	cambia_dir(yz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [c,v,c,v3,c,v,c2,v3] 
mossa_s_2t(cr8,[Bvr,Brg,Bga,Bav,[Cva,V1],[Cag,V2],[Cgr,V3],[Crv,V4]],  
	[Bvr,Brg,Bga,Bav,[Cag,Db],[Cgr,Dc],[Crv,Dd],[Cva,Da]],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,Ca,Cg,[Cr,S1],[Cv,S2]],	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,Ca,Cg,[Cv,Sb],[Cr,Sa]]):-
	cambia_dir(xz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(yz,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [c,r,c,r3,c,r,c2,r3] 
mossa_s_2t(cg8,[Bvr,Brg,Bga,Bav,[Cva,V1],[Cag,V2],[Cgr,V3],[Crv,V4]],  
	[Bvr,Brg,Bga,Bav,[Cag,Db],[Cgr,Dc],[Crv,Dd],[Cva,Da]],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,Ca,[Cg,S1],[Cr,S2],Cv],	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,Ca,[Cr,Sb],[Cg,Sa],Cv]):-
	cambia_dir(xz,V1,Da), cambia_dir(xy,V2,Db), cambia_dir(yz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [c,g,c,g3,c,g,c2,g3] 
mossa_s_2t(ca8,[Bvr,Brg,Bga,Bav,[Cva,V1],[Cag,V2],[Cgr,V3],[Crv,V4]],  
	[Bvr,Brg,Bga,Bav,[Cag,Db],[Cgr,Dc],[Crv,Dd],[Cva,Da]],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,[Ca,S1],[Cg,S2]|Rest],	[Bv,Br,Bg,Ba,Vr,Gr,Ga,Va,[Cg,Sb],[Ca,Sa]|Rest]):-
	cambia_dir(xz,V1,Da), cambia_dir(yz,V2,Db), cambia_dir(xz,V3,Dc), cambia_dir(xy,V4,Dd),
	cambia_dir(yz,S1,Sa), cambia_dir(yz,S2,Sb).	% [c,a,c,a3,c,a,c2,a3] 

% Le seguenti sono regole fatte ad hoc per gli spigoli gi posizionati, dunque non generali
mossa_s_o(bvr4x4,1,[Bvr,Brg,Bga,[Bav,V1],Cva,Cag,Cgr,[Crv,V2]], [Bvr,Brg,Bga,[Bav,Da],Cva,Cag,Cgr,[Crv,Db]],
	[[Bv,y],[Br,O]|Rest], [[Bv,x],[Br,O1]|Rest]):- ruota_antiorario(V1,Da), ruota_orario(V2,Db), 	cambia_dir(xz,O,O1).	% [b3,v,b,v3,b3,v,b,v3,r,v3,r3,v,r,v3,r3,v], cambia [bv,br]
mossa_s_o(brg4x4,2,[[Bvr,V1],Brg,Bga,Bav,Cva,Cag,[Cgr,V2],Crv],  [[Bvr,Da],Brg,Bga,Bav,Cva,Cag,[Cgr,Db],Crv],
	[Bv,[Br,z],[Bg,O]|Rest], [Bv,[Br,x],[Bg,O1]|Rest]):- ruota_orario(V1,Da), ruota_antiorario(V2,Db),
	 cambia_dir(xy,O,O1). % [b3,r,b,r3,b3,r,b,r3,g,r3,g3,r,g,r3,g3,r], cambia [br,bg]
mossa_s_o(bga4x4,3,[Bvr,[Brg,V1],Bga,Bav,Cva,[Cag,V2],Cgr,Crv],  [Bvr,[Brg,Da],Bga,Bav,Cva,[Cag,Db],Cgr,Crv],
	[Bv,Br,[Bg,y],[Ba,O]|Rest], [Bv,Br,[Bg,x],[Ba,O1]|Rest]):- ruota_antiorario(V1,Da), ruota_orario(V2,Db),
	 cambia_dir(xz,O,O1). % [b3,g,b,g3,b3,g,b,g3,a,g3,a3,g,a,g3,a3,g], cambia [bg,ba]
mossa_s_o(abg4x4,4,[Bvr,[Brg,V1],Bga,[Bav,V2]|VRest],  [Bvr,[Brg,Da],Bga,[Bav,Db]|VRest],
	[Bv,Br,Bg,[Ba,z],Vr,Gr,[Ga,O]|SRest], [Bv,Br,Bg,[Ba,x],Vr,Gr,[Ga,O1]|SRest]):- ruota_orario(V1,Da),
	ruota_antiorario(V2,Db), cambia_dir(yz,O,O1). % [a3,b,a,b3,a3,b,a,b3,g,b3,g3,b,g,b3,g3,b], cambia [ba,ga]
mossa_s_o(agc4x4,5,[Bvr,Brg,[Bga,V1],Bav,Cva,Cag,[Cgr,V2],Crv],  [Bvr,Brg,[Bga,Da],Bav,Cva,Cag,[Cgr,Db],Crv],
	[Bv,Br,Bg,Ba,Vr,Gr,[Ga,z],Va,[Ca,O]|SRest], [Bv,Br,Bg,Ba,Vr,Gr,[Ga,y],Va,[Ca,O1]|SRest]):- 
	ruota_orario(V1,Da),
	ruota_antiorario(V2,Db), cambia_dir(xz,O,O1). % [a3,g,a,g3,a3,g,a,g3,c,g3,c3,g,c,g3,c3,g], cambia [ga,ca]
mossa_s_o(acv4x4,6,[Bvr,Brg,Bga,Bav,Cva,[Cag,V1],Cgr,[Crv,V2]],  [Bvr,Brg,Bga,Bav,Cva,[Cag,Da],Cgr,[Crv,Db]],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,[Va,O],[Ca,z]|SRest], [Bv,Br,Bg,Ba,Vr,Gr,Ga,[Va,O1],[Ca,x]|SRest]):-
	ruota_orario(V2,Db), ruota_antiorario(V1,Da), cambia_dir(yz,O,O1).
	% [a3,c,a,c3,a3,c,a,c3,v,c3,v3,c,v,c3,v3,c], cambia [ca,va]
mossa_s_o(vac4x4,7,[Bvr,Brg,Bga,[Bav,V1],Cva,[Cag,V2]|Rest],  [Bvr,Brg,Bga,[Bav,Da],Cva,[Cag,Db]|Rest],
	[Bv,Br,Bg,Ba,Vr,Gr,Ga,[Va,z],Ca,Cg,Cr,[Cv,O]], [Bv,Br,Bg,Ba,Vr,Gr,Ga,[Va,y],Ca,Cg,Cr,[Cv,O1]]):- 
	ruota_orario(V2,Db), ruota_antiorario(V1,Da), cambia_dir(xy,O,O1). 
	% [v3,a,v,a3,v3,a,v,a3,c,a3,c3,a,c,a3,c3,a], cambia [va,cv]
mossa_s_o(vcr4x4,8,[Bvr,Brg,Bga,Bav,[Cva,V1],Cag,[Cgr,V2],Crv],  [Bvr,Brg,Bga,Bav,[Cva,Da],Cag,[Cgr,Db],Crv],
	[Bv,Br,Bg,Ba,[Vr,O],Gr,Ga,Va,Ca,Cg,Cr,[Cv,y]], [Bv,Br,Bg,Ba,[Vr,O1],Gr,Ga,Va,Ca,Cg,Cr,[Cv,x]]):- 
	ruota_orario(V1,Da),
	ruota_antiorario(V2,Db), cambia_dir(yz,O,O1). % [v3,c,v,c3,v3,c,v,c3,r,c3,r3,c,r,c3,r3,c], cambia [cv,vr]
mossa_s_o(rvc4x4,9,[[Bvr,V1],Brg,Bga,Bav,[Cva,V2]|Rest],  [[Bvr,Da],Brg,Bga,Bav,[Cva,Db]|Rest],
	[Bv,Br,Bg,Ba,[Vr,z],Gr,Ga,Va,Ca,Cg,[Cr,O],Cv], [Bv,Br,Bg,Ba,[Vr,y],Gr,Ga,Va,Ca,Cg,[Cr,O1],Cv]):- 
	ruota_orario(V1,Da),
	ruota_antiorario(V2,Db), cambia_dir(xz,O,O1). % [r3,v,r,v3,r3,v,r,v3,c,v3,c3,v,c,v3,c3,v], cambia [vr,cr]
mossa_s_o(rcg4x4,10,[Bvr,Brg,Bga,Bav,Cva,[Cag,V1],Cgr,[Crv,V2]],  [Bvr,Brg,Bga,Bav,Cva,[Cag,Da],Cgr,[Crv,Db]],
	[Bv,Br,Bg,Ba,Vr,[Gr,O],Ga,Va,Ca,Cg,[Cr,z],Cv], [Bv,Br,Bg,Ba,Vr,[Gr,O1],Ga,Va,Ca,Cg,[Cr,x],Cv]):- 
	ruota_orario(V1,Da),
	ruota_antiorario(V2,Db), cambia_dir(yz,O,O1). % [r3,c,r,c3,r3,c,r,c3,g,c3,g3,c,g,c3,g3,c], cambia [cr,gr]
mossa_s_o(grc4x4,11,[Bvr,[Brg,V1],Bga,Bav,Cva,Cag,Cgr,[Crv,V2]],  [Bvr,[Brg,Da],Bga,Bav,Cva,Cag,Cgr,[Crv,Db]],
	[Bv,Br,Bg,Ba,Vr,[Gr,z],Ga,Va,Ca,[Cg,O]|Rest], [Bv,Br,Bg,Ba,Vr,[Gr,y],Ga,Va,Ca,[Cg,O1]|Rest]):- 	
	ruota_orario(V2,Db),
	ruota_antiorario(V1,Da), cambia_dir(xy,O,O1). % [g3,r,g,r3,g3,r,g,r3,c,r3,c3,r,c,r3,c3,r], cambia [gr,cg]

% RUOTA_ORARIO e RUOTA_ANTIORARIO
ruota_orario(x,y):- !.
ruota_orario(y,z):- !.
ruota_orario(z,x).
ruota_antiorario(y,x):- !.
ruota_antiorario(z,y):- !.
ruota_antiorario(x,z).

% CAMBIA_DIR
cambia_dir(xy,z,z):- !. 
cambia_dir(xy,x,y):- !.
cambia_dir(xy,y,x).
cambia_dir(xz,y,y):- !.
cambia_dir(xz,x,z):- !.
cambia_dir(xz,z,x).
cambia_dir(yz,x,x):- !.
cambia_dir(yz,y,z):- !.
cambia_dir(yz,z,y).

% INIZIALIZZAZIONE
vertici_ko([[cag,z],[bvr,y],[cgr,y],[bav,z],[crv,z],[bga,y],[cva,y],[brg,z]]).
spigoli_ko([[ca,y],[gr,z],[vr,x],[bg,x],[br,y],[cg,y],[ba,y],[cv,y],[ga,x],[bv,y],[va,z],[cr,x]]).
% b,v2,r,g2,a,c,b3,v3,r3,a3,c2.	Per aggiustarli: c2,a,2,v,b,c3,a3,g2,r3,v2,b3.

% GO
go:- vertici_ko(V), spigoli_ko(S), trova_spigoli(V,Vn,S,0,1), nl,nl, write(V),nl,write(Vn), nl, nl, write('Finalmente'), nl.

% TROVA_SPIGOLI	
trova_spigoli(V,Vout,Spigoli,12,1):- !, nl, nl, orienta_spigoli(V,Vout,Spigoli,1).
trova_spigoli(V,Vout,S,Giusti,Profondit_max):- posizione_spigoli(S,Sequenza,z,Giusti,Profondit_max,0), !, 
	conta_mosse(Sequenza,Numero_mosse), calcola_stato_spigoli(V,S,Sequenza,Vn,Sn), 
	spigoli_fuori_posto(Sn,FP,D), n_primi_spigoli_a_posto(NGiusti,Sn), write('Primi '), write(NGiusti), 
	write(' spigoli giusti, dopo '), write(Numero_mosse), write(' mosse ('), write(Sequenza), write('), '), write(D),
	write(' spigoli fuori posto, cio:'), nl, write(FP), write('; posizioni attuali:'), nl, write(Sn), nl,
	spigoli_ok(S_ok), write(S_ok), write('  il goal.'), nl, write(Vn),nl, trova_spigoli(Vn,Vout,Sn,NGiusti,1).
trova_spigoli(V,Vn,S,Giusti,Profondit_max):- 
	P is Profondit_max+1, write('profondit: '), Pr is P-1, write(Pr),nl, trova_spigoli(V,Vn,S,Giusti,P).

% POSIZIONE_SPIGOLI
% Cerca di trovare una sequenza di mosse che porti ad avere un numero minore di "Diversi" spigoli fuori posto.
posizione_spigoli(S,[],_,N,_,_):- n_primi_spigoli_a_posto(Giusti,S),  Giusti>N, !.	% ho trovato!
posizione_spigoli(_,_,_,_,Profondit_max,Profondit_max):- !, fail. % forzo il backtracking
posizione_spigoli(Spigoli,[Mossa|Sequenza],Prec,N,Profondit_max,Profondit):- N<4, !,
	mossa_s(M,Prec,Mossa,Spigoli,Sn), P is Profondit+1, posizione_spigoli(Sn,Sequenza,M,N,Profondit_max,P).
posizione_spigoli(Spigoli,[Mossa|Sequenza],_,N,Profondit_max,Profondit):-
	mossa_s_2(Mossa,Spigoli,Sn), P is Profondit+1, posizione_spigoli(Sn,Sequenza,_,N,Profondit_max,P).

% CONTA_MOSSE
conta_mosse(Sequenza,Numero_mosse):- length(Sequenza,0,Numero_mosse).
length([],N,N).
length([_|T],Acc,Numero_mosse):- Acc1 is Acc+1, length(T,Acc1,Numero_mosse).

% SPIGOLI_FUORI_POSTO
spigoli_fuori_posto(Spigoli,FP,N):- spigoli_ok(S_ok), spigoli_fuori_posto(Spigoli,S_ok,FP,0,N).
spigoli_fuori_posto([],[],[],N,N).
spigoli_fuori_posto([[H,_]|T],[[H,_]|T1],L,Acc,N):-  !, spigoli_fuori_posto(T,T1,L,Acc,N).
spigoli_fuori_posto([[H,O]|T],[[H1,O1]|T1],[[[H,O],[H1,O1]]|L],Acc,N):- 
	Acc1 is Acc+1, spigoli_fuori_posto(T,T1,L,Acc1,N).

% N_PRIMI_SPIGOLI_A_POSTO
n_primi_spigoli_a_posto(N,Spigoli):- spigoli_ok(S_ok), n_primi_spigoli_a_posto(Spigoli,S_ok,0,N).

n_primi_spigoli_a_posto([[H,_]|T],[[H,_]|T1],Acc,N):- !, Acc1 is Acc+1, n_primi_spigoli_a_posto(T,T1,Acc1,N).
n_primi_spigoli_a_posto(_,_,N,N). % termina quando non ci sono pi spigoli giusti nei primi posti.

% CALCOLA_STATO_SPIGOLI
calcola_stato_spigoli(V,S,[],V,S).
calcola_stato_spigoli(V,S,[Mossa|Sequenza],Vn,Sn):- mossa(_,z,Mossa,V,V1,S,S1), !,
	calcola_stato_spigoli(V1,S1,Sequenza,Vn,Sn).
calcola_stato_spigoli(V,S,[Mossa|Sequenza],Vn,Sn):- mossa_s_2t(Mossa,V,V1,S,S1), 
	calcola_stato_spigoli(V1,S1,Sequenza,Vn,Sn).

% ORIENTA_SPIGOLI
orienta_spigoli(V,V,Spigoli,12):- nl, write('Spigoli tutti a posto:'), nl, write(Spigoli).
orienta_spigoli(V,Vout,Spigoli,N):- mossa_s_o(Mossa,N,V,Vn,Spigoli,Sn), write(N), write(' spigoli orientati, con '),
	write(Mossa), write(';'), nl, write(Spigoli), write(' prima;'), nl, write(Sn), write(' dopo.'),nl,
	N1 is N+1, orienta_spigoli(Vn,Vout,Sn,N1).
orienta_spigoli(V,Vout,Spigoli,N):- N1 is N+1, orienta_spigoli(V,Vout,Spigoli,N1).
